#include "EsoAcsammm_Header.hpp"
/* Copyright (C) 1991-2017 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <http://www.gnu.org/licenses/>.  */
/* This header is separate from features.h so that the compiler can
   include it implicitly at the start of every compilation.  It must
   not itself include <features.h> or any other header that includes
   <features.h> because the implicit include comes before any feature
   test macros that may be defined in a source file before it first
   explicitly includes a system header.  GCC knows the name of this
   header in order to preinclude it.  */
/* glibc's intent is to support the IEC 559 math functionality, real
   and complex.  If the GCC (4.9 and later) predefined macros
   specifying compiler intent are available, use them to determine
   whether the overall intent is to support these features; otherwise,
   presume an older compiler has intent to support these features and
   define these macros by default.  */
/* wchar_t uses Unicode 10.0.0.  Version 10.0 of the Unicode Standard is
   synchronized with ISO/IEC 10646:2017, fifth edition, plus
   the following additions from Amendment 1 to the fifth edition:
   - 56 emoji characters
   - 285 hentaigana
   - 3 additional Zanabazar Square characters */
/* We do not support C11 <threads.h>.  */
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++
void a1_res(int bmode_1, double* yy, double* a1_yy, double* der_x, double* a1_der_x, double* x, double* a1_x, double* p, double* a1_p, int* condit, int* lock, int* prev, int& n_x, int& n_p, int& n_c)
#pragma ad indep x a1_x p a1_p a1_yy
#pragma ad dep yy a1_x a1_p
{
   int i_E=0;
   int i_C=0;
   int i__=0;
   int j__=0;
   int k__=0;
   int m__=0;
   int r_i=0;
   int r_j=0;
   int i_a=0;
   int i_b=0;
   int i_loop=0;
   int i__switch=0;
   int i__start=0;
   int i__end=0;
   int i__step=0;
   int while_end=0;
   int i_cont=0;
   int j_cont=0;
   int k_cont=0;
   double var_tim=0;
   double a1_var_tim=0;
   double der_var_tim=0;
   double a1_der_var_tim=0;
   double var_x=0;
   double a1_var_x=0;
   double der_var_x=0;
   double a1_der_var_x=0;
   double var_y=0;
   double a1_var_y=0;
   double der_var_y=0;
   double a1_der_var_y=0;
   double var_z=0;
   double a1_var_z=0;
   double der_var_z=0;
   double a1_der_var_z=0;
   double var_testvar1=0;
   double a1_var_testvar1=0;
   double der_var_testvar1=0;
   double a1_der_var_testvar1=0;
   double var_testvar2=0;
   double a1_var_testvar2=0;
   double der_var_testvar2=0;
   double a1_der_var_testvar2=0;
   double par_Para=0;
   double a1_par_Para=0;
   double par_Cont=0;
   double a1_par_Cont=0;
   double var_pow0=0;
   double a1_var_pow0=0;
   double var_i_expr=0;
   double a1_var_i_expr=0;
   double var_pow1=0;
   double a1_var_pow1=0;
   double var_i_expr2=0;
   double a1_var_i_expr2=0;
   int i_i=0;
   int i_j=0;
   int i_z=0;
   double v1_0=0;
   double a1_v1_0=0;
   double v1_1=0;
   double a1_v1_1=0;
   double v1_2=0;
   double a1_v1_2=0;
   double v1_3=0;
   double a1_v1_3=0;
   double v1_4=0;
   double a1_v1_4=0;
   double v1_5=0;
   double a1_v1_5=0;
   double v1_6=0;
   double a1_v1_6=0;
   double v1_7=0;
   double a1_v1_7=0;
   double v1_8=0;
   double a1_v1_8=0;
   double v1_9=0;
   double a1_v1_9=0;
   double v1_10=0;
   double a1_v1_10=0;
   double v1_11=0;
   double a1_v1_11=0;
   double v1_12=0;
   double a1_v1_12=0;
   double v1_13=0;
   double a1_v1_13=0;
   double v1_14=0;
   double a1_v1_14=0;
   int save_acs_cs_c=0;
   save_acs_cs_c=acs_cs_c;
   if (bmode_1==1) {
      // augmented forward section
      acs_cs[acs_cs_c]=0; acs_cs_c=acs_cs_c+1;
      acs_fds[acs_fds_c]=var_tim; acs_fds_c=acs_fds_c+1; var_tim=x[0];
      acs_fds[acs_fds_c]=der_var_tim; acs_fds_c=acs_fds_c+1; der_var_tim=der_x[0];
      acs_fds[acs_fds_c]=var_x; acs_fds_c=acs_fds_c+1; var_x=x[1];
      acs_fds[acs_fds_c]=der_var_x; acs_fds_c=acs_fds_c+1; der_var_x=der_x[1];
      acs_fds[acs_fds_c]=var_y; acs_fds_c=acs_fds_c+1; var_y=x[2];
      acs_fds[acs_fds_c]=der_var_y; acs_fds_c=acs_fds_c+1; der_var_y=der_x[2];
      acs_fds[acs_fds_c]=var_z; acs_fds_c=acs_fds_c+1; var_z=x[3];
      acs_fds[acs_fds_c]=der_var_z; acs_fds_c=acs_fds_c+1; der_var_z=der_x[3];
      acs_fds[acs_fds_c]=var_testvar1; acs_fds_c=acs_fds_c+1; var_testvar1=x[4];
      acs_fds[acs_fds_c]=der_var_testvar1; acs_fds_c=acs_fds_c+1; der_var_testvar1=der_x[4];
      acs_fds[acs_fds_c]=var_testvar2; acs_fds_c=acs_fds_c+1; var_testvar2=x[5];
      acs_fds[acs_fds_c]=der_var_testvar2; acs_fds_c=acs_fds_c+1; der_var_testvar2=der_x[5];
      acs_fds[acs_fds_c]=par_Para; acs_fds_c=acs_fds_c+1; par_Para=p[0];
      acs_fds[acs_fds_c]=par_Cont; acs_fds_c=acs_fds_c+1; par_Cont=p[1];
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=2*der_var_tim-(1*2);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=var_i_expr; acs_fds_c=acs_fds_c+1; var_i_expr=2;
      bmode_1=2; // store inputs and run original code
      a1_acs_pow(bmode_1,par_Para,a1_par_Para,var_i_expr,a1_var_i_expr,var_pow0,a1_var_pow0);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_x-(0-2*var_tim+4+var_pow0);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=var_i_expr2; acs_fds_c=acs_fds_c+1; var_i_expr2=3;
      bmode_1=2; // store inputs and run original code
      a1_acs_pow(bmode_1,var_testvar1,a1_var_testvar1,var_i_expr2,a1_var_i_expr2,var_pow1,a1_var_pow1);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=3*der_var_y-((2*var_y+var_z+var_pow1)*3);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=4*der_var_z-(var_z*var_tim*4);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_testvar1-(var_x+var_y+par_Cont);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_testvar2-(var_x-var_y);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_ids[acs_ids_c]=n_c; acs_ids_c=acs_ids_c+1; n_c=i_C;
      // For the case you need the actual function value at the end of the forward section, use this mode for storing it.
      // reverse section
      while (acs_cs_c>save_acs_cs_c) {
            acs_cs_c=acs_cs_c-1;
            if (acs_cs[acs_cs_c]==0) {
              acs_ids_c=acs_ids_c-1; n_c=acs_ids[acs_ids_c];
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_testvar2;
              v1_1=var_x;
              v1_2=var_y;
              v1_3=v1_1-v1_2;
              v1_4=v1_3;
              v1_5=v1_0-v1_4;
              a1_v1_5=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_5; a1_v1_4=0-a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=a1_v1_3; a1_v1_2=0-a1_v1_3;
              a1_var_y=a1_var_y+a1_v1_2;
              a1_var_x=a1_var_x+a1_v1_1;
              a1_var_testvar2=a1_var_testvar2+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_testvar1;
              v1_1=var_x;
              v1_2=var_y;
              v1_3=v1_1+v1_2;
              v1_4=par_Cont;
              v1_5=v1_3+v1_4;
              v1_6=v1_5;
              v1_7=v1_0-v1_6;
              a1_v1_7=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_7; a1_v1_6=0-a1_v1_7;
              a1_v1_5=a1_v1_6;
              a1_v1_3=a1_v1_5; a1_v1_4=a1_v1_5;
              a1_par_Cont=a1_par_Cont+a1_v1_4;
              a1_v1_1=a1_v1_3; a1_v1_2=a1_v1_3;
              a1_var_y=a1_var_y+a1_v1_2;
              a1_var_x=a1_var_x+a1_v1_1;
              a1_var_testvar1=a1_var_testvar1+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=4;
              v1_1=der_var_z;
              v1_2=v1_0*v1_1;
              v1_3=var_z;
              v1_4=var_tim;
              v1_5=v1_3*v1_4;
              v1_6=4;
              v1_7=v1_5*v1_6;
              v1_8=v1_7;
              v1_9=v1_2-v1_8;
              a1_v1_9=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_2=a1_v1_9; a1_v1_8=0-a1_v1_9;
              a1_v1_7=a1_v1_8;
              a1_v1_5=v1_6*a1_v1_7; a1_v1_6=v1_5*a1_v1_7;
              a1_v1_3=v1_4*a1_v1_5; a1_v1_4=v1_3*a1_v1_5;
              a1_var_tim=a1_var_tim+a1_v1_4;
              a1_var_z=a1_var_z+a1_v1_3;
              a1_v1_0=v1_1*a1_v1_2; a1_v1_1=v1_0*a1_v1_2;
              a1_der_var_z=a1_der_var_z+a1_v1_1;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=3;
              v1_1=der_var_y;
              v1_2=v1_0*v1_1;
              v1_3=2;
              v1_4=var_y;
              v1_5=v1_3*v1_4;
              v1_6=var_z;
              v1_7=v1_5+v1_6;
              v1_8=var_pow1;
              v1_9=v1_7+v1_8;
              v1_10=v1_9;
              v1_11=3;
              v1_12=v1_10*v1_11;
              v1_13=v1_12;
              v1_14=v1_2-v1_13;
              a1_v1_14=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_2=a1_v1_14; a1_v1_13=0-a1_v1_14;
              a1_v1_12=a1_v1_13;
              a1_v1_10=v1_11*a1_v1_12; a1_v1_11=v1_10*a1_v1_12;
              a1_v1_9=a1_v1_10;
              a1_v1_7=a1_v1_9; a1_v1_8=a1_v1_9;
              a1_var_pow1=a1_var_pow1+a1_v1_8;
              a1_v1_5=a1_v1_7; a1_v1_6=a1_v1_7;
              a1_var_z=a1_var_z+a1_v1_6;
              a1_v1_3=v1_4*a1_v1_5; a1_v1_4=v1_3*a1_v1_5;
              a1_var_y=a1_var_y+a1_v1_4;
              a1_v1_0=v1_1*a1_v1_2; a1_v1_1=v1_0*a1_v1_2;
              a1_der_var_y=a1_der_var_y+a1_v1_1;
              bmode_1=1; // restore and joint reversal
          a1_acs_pow(bmode_1,var_testvar1,a1_var_testvar1,var_i_expr2,a1_var_i_expr2,var_pow1,a1_var_pow1);
              acs_fds_c=acs_fds_c-1; var_i_expr2=acs_fds[acs_fds_c];
              v1_0=3;
              a1_v1_0=a1_var_i_expr2; a1_var_i_expr2=0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_x;
              v1_1=2;
              v1_2=var_tim;
              v1_3=v1_1*v1_2;
              v1_4=-v1_3;
              v1_5=4;
              v1_6=v1_4+v1_5;
              v1_7=var_pow0;
              v1_8=v1_6+v1_7;
              v1_9=v1_8;
              v1_10=v1_0-v1_9;
              a1_v1_10=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_10; a1_v1_9=0-a1_v1_10;
              a1_v1_8=a1_v1_9;
              a1_v1_6=a1_v1_8; a1_v1_7=a1_v1_8;
              a1_var_pow0=a1_var_pow0+a1_v1_7;
              a1_v1_4=a1_v1_6; a1_v1_5=a1_v1_6;
              a1_v1_3=-a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_tim=a1_var_tim+a1_v1_2;
              a1_der_var_x=a1_der_var_x+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_pow(bmode_1,par_Para,a1_par_Para,var_i_expr,a1_var_i_expr,var_pow0,a1_var_pow0);
              acs_fds_c=acs_fds_c-1; var_i_expr=acs_fds[acs_fds_c];
              v1_0=2;
              a1_v1_0=a1_var_i_expr; a1_var_i_expr=0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=2;
              v1_1=der_var_tim;
              v1_2=v1_0*v1_1;
              v1_3=1;
              v1_4=2;
              v1_5=v1_3*v1_4;
              v1_6=v1_5;
              v1_7=v1_2-v1_6;
              a1_v1_7=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_2=a1_v1_7; a1_v1_6=0-a1_v1_7;
              a1_v1_5=a1_v1_6;
              a1_v1_3=v1_4*a1_v1_5; a1_v1_4=v1_3*a1_v1_5;
              a1_v1_0=v1_1*a1_v1_2; a1_v1_1=v1_0*a1_v1_2;
              a1_der_var_tim=a1_der_var_tim+a1_v1_1;
              acs_fds_c=acs_fds_c-1; par_Cont=acs_fds[acs_fds_c];
              v1_0=p[1];
              a1_v1_0=a1_par_Cont; a1_par_Cont=0;
              a1_p[1]=a1_p[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_Para=acs_fds[acs_fds_c];
              v1_0=p[0];
              a1_v1_0=a1_par_Para; a1_par_Para=0;
              a1_p[0]=a1_p[0]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_testvar2=acs_fds[acs_fds_c];
              v1_0=der_x[5];
              a1_v1_0=a1_der_var_testvar2; a1_der_var_testvar2=0;
              a1_der_x[5]=a1_der_x[5]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_testvar2=acs_fds[acs_fds_c];
              v1_0=x[5];
              a1_v1_0=a1_var_testvar2; a1_var_testvar2=0;
              a1_x[5]=a1_x[5]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_testvar1=acs_fds[acs_fds_c];
              v1_0=der_x[4];
              a1_v1_0=a1_der_var_testvar1; a1_der_var_testvar1=0;
              a1_der_x[4]=a1_der_x[4]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_testvar1=acs_fds[acs_fds_c];
              v1_0=x[4];
              a1_v1_0=a1_var_testvar1; a1_var_testvar1=0;
              a1_x[4]=a1_x[4]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_z=acs_fds[acs_fds_c];
              v1_0=der_x[3];
              a1_v1_0=a1_der_var_z; a1_der_var_z=0;
              a1_der_x[3]=a1_der_x[3]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_z=acs_fds[acs_fds_c];
              v1_0=x[3];
              a1_v1_0=a1_var_z; a1_var_z=0;
              a1_x[3]=a1_x[3]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_y=acs_fds[acs_fds_c];
              v1_0=der_x[2];
              a1_v1_0=a1_der_var_y; a1_der_var_y=0;
              a1_der_x[2]=a1_der_x[2]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_y=acs_fds[acs_fds_c];
              v1_0=x[2];
              a1_v1_0=a1_var_y; a1_var_y=0;
              a1_x[2]=a1_x[2]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_x=acs_fds[acs_fds_c];
              v1_0=der_x[1];
              a1_v1_0=a1_der_var_x; a1_der_var_x=0;
              a1_der_x[1]=a1_der_x[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_x=acs_fds[acs_fds_c];
              v1_0=x[1];
              a1_v1_0=a1_var_x; a1_var_x=0;
              a1_x[1]=a1_x[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_tim=acs_fds[acs_fds_c];
              v1_0=der_x[0];
              a1_v1_0=a1_der_var_tim; a1_der_var_tim=0;
              a1_der_x[0]=a1_der_x[0]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_tim=acs_fds[acs_fds_c];
              v1_0=x[0];
              a1_v1_0=a1_var_tim; a1_var_tim=0;
              a1_x[0]=a1_x[0]+a1_v1_0;
            }
          }
       }
       if (bmode_1==2) {
          res(yy, der_x, x, p, condit, lock, prev, n_x, n_p, n_c);
       }
}
